kind: "Template"
apiVersion: "v1"
metadata:
  name: "tsm-k8s"
  annotations:
    description: "A cronjob to perform TSM Backups"
labels:
  template: "tsm" #this label will be applied to all objects created from this template
objects:
  - 
    kind: CronJob
    apiVersion: batch/v1beta1
    metadata:
      labels:
        app: tsm
      name: "tsm-backup-job"
    spec:
      concurrencyPolicy: Replace
      successfulJobsHistoryLimit: 3
      failedJobsHistoryLimit: 3 
      schedule: "0 */4 * * *"
      jobTemplate:
        spec:
          metadata:
            labels:
              app: tsm
          template:
               metadata:
                 labels:          
                   parent: "tsm"
               spec:
                 containers:
                   - name: "tsm-backup"
                     env:
                     - name: USE_CONFIG_MAP
                       value: "Y"
                     - name: DSM_CONFIG_DIR
                       value: /etc/dsm
                     - name: TSM_PASSWORD
                       valueFrom:
                         secretKeyRef:
                           name: tsm-password-secret
                           key: TSM_PASSWORD
                     image: gitlab-registry.cern.ch/industrial-controls/sw-infra/tsm-k8s:baseline
                     imagePullPolicy: Always
                     dnsPolicy: ClusterFirst
                     terminationGracePeriodSeconds: 12000
                     volumeMounts:
                     - name: tsm-log-volume
                       mountPath: /var/log
                     - name: tsm-cfg-volume
                       mountPath: /etc/dsm
                     - mountPath: ${MOUNT_POINT_PARAM}
                       name: contents
                       readOnly: true
                     command: ["/entrypoint.sh"]
                 volumes:
                   - name: tsm-log-volume
                     persistentVolumeClaim:
                         claimName: tsm-log-pvc
                   - name: tsm-cfg-volume
                     configMap:
                         name: dsm-config-map
                   - name: contents
                     persistentVolumeClaim:
                         claimName: ${MOUNT_PVC_PARAM}
                 restartPolicy: OnFailure
  - 
    kind: PersistentVolumeClaim
    apiVersion: v1
    metadata:
      name: tsm-log-pvc
      labels:
        app: tsm
    spec:
      accessModes:
        - ReadWriteOnce
      resources:
        requests:
          storage: 3Gi
  -
    kind: "ConfigMap"
    apiVersion: "v1"
    metadata:
      name: "dsm-config-map"
      labels:
        app: tsm
    data:
      dsm.opt: |
        SErvername AUTODETECT
        Tapeprompt    No
        DATEFORMAT 2
        DOMain ${MOUNT_POINT_PARAM}
      dsm.sys: |
        SErvername AUTODETECT
        NODename	${NODE_NAME_PARAM}
        Passwordaccess	prompt
        COMMmethod	TCPip
        TCPPort	1700
        TCPServeraddress	${NODE_NAME_PARAM}.backup.cern.ch
        ERRORLogName	/var/log/dsmerror.log
        SCHEDLogName	/var/log/dsmsched.log
        ERRORLOGRetention	10
        SCHEDLOGRetention	10
        VIRTUALMountpoint	${MOUNT_POINT_PARAM}
        MANAGEDServices	schedule
  -
    kind: "Secret"
    apiVersion: "v1"
    metadata:
      name: "tsm-password-secret"
      labels:
        app: tsm
    stringData:
      TSM_PASSWORD: ${TSM_PASSWORD_PARAM}
parameters:
  -
    name: "TSM_PASSWORD_PARAM"
    description: "Your TSM Password"
    required: true
  -
    name: "NODE_NAME_PARAM"
    description: "Your TSM Node Name"
    required: true
  -
    name: "MOUNT_POINT_PARAM"
    description: "The path you wish to backup"
    value: /var/svn
  -
    name: "MOUNT_PVC_PARAM"
    description: "The persistent volume claim you wish to backup"
    value: repository
